JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
LADSPAPluginFormat Class Reference
juce_audio_processors » format_types

Implements a plugin format manager for LADSPA plugins. More...

`#include <juce_LADSPAPluginFormat.h>`

Inheritance diagram for LADSPAPluginFormat:

## Public Member Functions
| LADSPAPluginFormat ()
| ~LADSPAPluginFormat () override
String | getName () const override
| Returns the format name.
bool | canScanForPlugins () const override
| Returns true if this format needs to run a scan to find its list of plugins.
bool | isTrivialToScan () const override
| Should return true if this format is both safe and quick to scan - i.e.
void | findAllTypesForFile (OwnedArray< PluginDescription > &, const String &fileOrIdentifier) override
| This tries to create descriptions for all the plugin types available in a binary module file.
bool | fileMightContainThisPluginType (const String &fileOrIdentifier) override
| Should do a quick check to see if this file or directory might be a plugin of this format.
String | getNameOfPluginFromIdentifier (const String &fileOrIdentifier) override
| Returns a readable version of the name of the plugin that this identifier refers to.
bool | pluginNeedsRescanning (const PluginDescription &) override
| Returns true if this plugin's version or date has changed and it should be re-checked.
StringArray | searchPathsForPlugins (const FileSearchPath &, bool recursive, bool) override
| Searches a suggested set of directories for any plugins in this format.
bool | doesPluginStillExist (const PluginDescription &) override
| Checks whether this plugin could possibly be loaded.
FileSearchPath | getDefaultLocationsToSearch () override
| Returns the typical places to look for this kind of plugin.
Public Member Functions inherited from AudioPluginFormat
| ~AudioPluginFormat () override
| Destructor.
std::unique_ptr< AudioPluginInstance > | createInstanceFromDescription (const PluginDescription &, double initialSampleRate, int initialBufferSize)
| Tries to recreate a type from a previously generated PluginDescription.
std::unique_ptr< AudioPluginInstance > | createInstanceFromDescription (const PluginDescription &, double initialSampleRate, int initialBufferSize, String &errorMessage)
| Same as above but with the possibility of returning an error message.
void | createPluginInstanceAsync (const PluginDescription &description, double initialSampleRate, int initialBufferSize, PluginCreationCallback)
| Tries to recreate a type from a previously generated PluginDescription.
virtual void | createARAFactoryAsync (const PluginDescription &, ARAFactoryCreationCallback callback)
| Tries to create an ARAFactoryWrapper for this description.

## Static Public Member Functions
static String | getFormatName ()

## Additional Inherited Members
Public Types inherited from AudioPluginFormat
using | PluginCreationCallback = std::function<void (std::unique_ptr<AudioPluginInstance>, const String&)>
| A callback lambda that is passed to createPluginInstanceAsync()
using | ARAFactoryCreationCallback = std::function<void (ARAFactoryResult)>
| A callback lambda that is passed to getARAFactory()
Protected Member Functions inherited from AudioPluginFormat
| AudioPluginFormat ()

## Detailed Description

Implements a plugin format manager for LADSPA plugins.

## Constructor & Destructor Documentation

## ◆ LADSPAPluginFormat()

LADSPAPluginFormat::LADSPAPluginFormat | ( |  | ) |

## ◆ ~LADSPAPluginFormat()

LADSPAPluginFormat::~LADSPAPluginFormat | ( |  | ) |
| override

## Member Function Documentation

## ◆ getFormatName()

static String LADSPAPluginFormat::getFormatName | ( |  | ) |
| static

## ◆ getName()

String LADSPAPluginFormat::getName | ( |  | ) | const
| override virtual

Returns the format name.

E.g. "VST", "AudioUnit", etc.

Implements AudioPluginFormat.

## ◆ canScanForPlugins()

bool LADSPAPluginFormat::canScanForPlugins | ( |  | ) | const
| override virtual

Returns true if this format needs to run a scan to find its list of plugins.

Implements AudioPluginFormat.

## ◆ isTrivialToScan()

bool LADSPAPluginFormat::isTrivialToScan | ( |  | ) | const
| override virtual

Should return true if this format is both safe and quick to scan - i.e.

if a file can be scanned within a few milliseconds on a background thread, without actually needing to load an executable.

Implements AudioPluginFormat.

## ◆ findAllTypesForFile()

void LADSPAPluginFormat::findAllTypesForFile | ( | OwnedArray< PluginDescription > & | results,
|  | const String & | fileOrIdentifier )
| override virtual

This tries to create descriptions for all the plugin types available in a binary module file.

The file will be some kind of DLL or bundle.

Normally there will only be one type returned, but some plugins (e.g. VST shells) can use a single DLL to create a set of different plugin subtypes, so in that case, each subtype is returned as a separate object.

Implements AudioPluginFormat.

## ◆ fileMightContainThisPluginType()

bool LADSPAPluginFormat::fileMightContainThisPluginType | ( | const String & | fileOrIdentifier | ) |
| override virtual

Should do a quick check to see if this file or directory might be a plugin of this format.

This is for searching for potential files, so it shouldn't actually try to load the plugin or do anything time-consuming.

Implements AudioPluginFormat.

## ◆ getNameOfPluginFromIdentifier()

String LADSPAPluginFormat::getNameOfPluginFromIdentifier | ( | const String & | fileOrIdentifier | ) |
| override virtual

Returns a readable version of the name of the plugin that this identifier refers to.

Implements AudioPluginFormat.

## ◆ pluginNeedsRescanning()

bool LADSPAPluginFormat::pluginNeedsRescanning | ( | const PluginDescription & |  | ) |
| override virtual

Returns true if this plugin's version or date has changed and it should be re-checked.

Implements AudioPluginFormat.

## ◆ searchPathsForPlugins()

StringArray LADSPAPluginFormat::searchPathsForPlugins | ( | const FileSearchPath & | directoriesToSearch,
|  | bool | recursive,
|  | bool | allowPluginsWhichRequireAsynchronousInstantiation )
| override virtual

Searches a suggested set of directories for any plugins in this format.

The path might be ignored, e.g. by AUs, which are found by the OS rather than manually.

Parameters

  directoriesToSearch | This specifies which directories shall be searched for plug-ins.
  recursive | Should the search recursively traverse folders.
  allowPluginsWhichRequireAsynchronousInstantiation | If this is false then plug-ins which require asynchronous creation will be excluded.

Implements AudioPluginFormat.

## ◆ doesPluginStillExist()

bool LADSPAPluginFormat::doesPluginStillExist | ( | const PluginDescription & |  | ) |
| override virtual

Checks whether this plugin could possibly be loaded.

It doesn't actually need to load it, just to check whether the file or component still exists.

Implements AudioPluginFormat.

## ◆ getDefaultLocationsToSearch()

FileSearchPath LADSPAPluginFormat::getDefaultLocationsToSearch | ( |  | ) |
| override virtual

Returns the typical places to look for this kind of plugin.

Note that if this returns no paths, it means that the format doesn't search in files or folders, e.g. AudioUnits.

Implements AudioPluginFormat.

The documentation for this class was generated from the following file:

- juce_LADSPAPluginFormat.h